package com.sf.web.dms.rtu.control;

package ..deTemp.1736265995204;

import com.sf.web.dms.rtu.entity.FesRtu;
import com.sf.web.dms.rtu.entity.RtuOptEvent;
import com.sf.web.dms.rtu.service.FesRtuService;
import com.sf.web.dms.rtu.service.RtuOptEventService;
import com.sf.web.dms.rtu.service.RtuSettingsService;
import com.sf.web.dms.rtu.service.RtuZoneService;
import com.sf.web.dms.util.SysCommUtil;
import com.smartframework.core.annotation.SmartComment;
import com.smartframework.core.dao.JdbcDao;
import com.smartframework.core.dao.page.PagingBean;
import com.smartframework.core.i18n.I18n;
import com.smartframework.core.smart.SmartView;
import com.smartframework.web.core.bean.HeaderConfig;
import com.smartframework.web.core.control.BasicControl;
import com.smartframework.web.core.queryfilter.QueryFilter;
import com.smartframework.web.core.util.DateUtil;
import com.smartframework.web.core.util.ExcelDataUtil;
import com.smartframework.web.core.util.JsonUtil;
import com.smartframework.web.core.util.ParameterUtils;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.IOException;
import java.io.InputStream;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import org.apache.commons.codec.binary.Base64;
import org.springframework.web.multipart.MultipartFile;

@SmartComment("FesRtu实例增删改查接口层")
public class FesRtuControl extends BasicControl {
  private FesRtuService fesRtuService;
  
  private RtuSettingsService rtuSettingsService;
  
  private RtuZoneService rtuZoneService;
  
  private RtuOptEventService rtuOptEventService;
  
  private JdbcDao jdbcDao;
  
  public JdbcDao getJdbcDao() {
    return this.jdbcDao;
  }
  
  public void setJdbcDao(JdbcDao jdbcDao) {
    this.jdbcDao = jdbcDao;
  }
  
  public RtuOptEventService getRtuOptEventService() {
    return this.rtuOptEventService;
  }
  
  public void setRtuOptEventService(RtuOptEventService rtuOptEventService) {
    this.rtuOptEventService = rtuOptEventService;
  }
  
  public RtuZoneService getRtuZoneService() {
    return this.rtuZoneService;
  }
  
  public void setRtuZoneService(RtuZoneService rtuZoneService) {
    this.rtuZoneService = rtuZoneService;
  }
  
  public RtuSettingsService getRtuSettingsService() {
    return this.rtuSettingsService;
  }
  
  public void setRtuSettingsService(RtuSettingsService rtuSettingsService) {
    this.rtuSettingsService = rtuSettingsService;
  }
  
  public FesRtuService getFesRtuService() {
    return this.fesRtuService;
  }
  
  public void setFesRtuService(FesRtuService fesRtuService) {
    this.fesRtuService = fesRtuService;
  }
  
  public SmartView rtuInfoList() {
    return SmartView.SUCCESS(this.fesRtuService.rtuInfoList());
  }
  
  @SmartComment("通过终端视图树获取rtu电池信息")
  public SmartView rtuTimeListByType(Integer orgId, Integer orgLevel, Long stationId, Long feederId, Integer rtuType, Integer rtuId, String name, Integer pageSize, Integer pageIndex, String columns, String method) {
    QueryFilter filter = new QueryFilter();
    filter.setPageInfo(pageSize, pageIndex);
    PagingBean page = this.fesRtuService.loadRtuTimeList(orgId, orgLevel, stationId, feederId, rtuType, rtuId, name, filter);
    if ("export".equals(method)) {
      List<HeaderConfig> headers = JsonUtil.getBeanListByJsonArray(columns, HeaderConfig.class);
      ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
      try {
        ExcelDataUtil.createExcelByMapList(page.getData(), headers).write(outputStream);
      } catch (IOException e) {
        return SmartView.ERROR(I18n.message("error.excel.export", new Object[] { e
                .getMessage() }));
      } 
      return SmartView.FileView(outputStream, "对时信息.xls");
    } 
    return SmartView.PAGEDATA(page);
  }
  
  public String getFileToByte(MultipartFile multipartFile) {
    byte[] by = new byte[(int)multipartFile.getSize()];
    try {
      InputStream is = multipartFile.getInputStream();
      ByteArrayOutputStream bytestream = new ByteArrayOutputStream();
      byte[] bb = new byte[2048];
      int ch = is.read(bb);
      while (ch != -1) {
        bytestream.write(bb, 0, ch);
        ch = is.read(bb);
      } 
      by = bytestream.toByteArray();
    } catch (Exception ex) {
      ex.printStackTrace();
    } 
    return Base64.encodeBase64String(by);
  }
  
  @SmartComment("通过终端视图树获取rtu及最新的一次操作记录")
  public SmartView rtuLastOptimeByType(String type, String subType, String id, String name) {
    List<Map<String, Object>> list = this.fesRtuService.getRtuLastOpTimeByType(type, subType, id, name);
    return SmartView.SUCCESS(list);
  }
  
  @SmartComment("")
  public SmartView rtuInfoAndLastOptTime(Integer orgId, Integer orgLevel, Long stationId, Long feederId, Integer rtuType, Integer rtuId, String name, Integer pageSize, Integer pageIndex, String columns, String method) {
    QueryFilter filter = new QueryFilter();
    filter.setPageInfo(pageSize, pageIndex);
    PagingBean page = this.fesRtuService.rtuInfoAndLastOptTime(orgId, orgLevel, stationId, feederId, rtuType, rtuId, name, filter);
    if ("export".equals(method))
      return SysCommUtil.exportExcel(columns, page, "软件升级.xls"); 
    return SmartView.PAGEDATA(page);
  }
  
  @SmartComment("更新召唤参数、下发参数记录")
  public SmartView saveRtuParam(List<Map<String, Object>> rtuSettings) {
    return SmartView.SUCCESS(this.rtuSettingsService
        .saveRtuParam(rtuSettings));
  }
  
  @SmartComment("根据RtuId,ADDR从参数设置表中取出对应的记录,批量参数配置处理")
  public SmartView loadParamInfoByRtuidAndAddr(List<Map<String, Object>> rtuSettings, int zone) {
    List<Map<String, Object>> list = this.rtuSettingsService.listRtuParamByRtuIdAndAddr(rtuSettings, zone);
    String rtuId = "";
    String newRtuId = "";
    String addr = "";
    String newAddr = "";
    List<Map<String, Object>> resultSettings = new ArrayList<>();
    for (int i = 0; i < rtuSettings.size(); i++) {
      Map<String, Object> settingMap = rtuSettings.get(i);
      for (int j = 0; j < list.size(); j++) {
        Map<String, Object> newMap = list.get(j);
        if (settingMap.get("rtuId") != null)
          rtuId = settingMap.get("rtuId").toString(); 
        if (newMap.get("rtuId") != null)
          newRtuId = newMap.get("rtuId").toString(); 
        if (settingMap.get("addr") != null)
          addr = settingMap.get("addr").toString(); 
        if (newMap.get("paramaddr") != null)
          newAddr = newMap.get("paramaddr").toString(); 
        System.out.println(rtuId + ":" + newRtuId + "||" + addr + ":" + newAddr);
        if (rtuId.equals(newRtuId) && addr.equals(newAddr)) {
          settingMap = newMap;
          break;
        } 
      } 
      resultSettings.add(settingMap);
    } 
    return SmartView.SUCCESS(resultSettings);
  }
  
  @SmartComment("根据RtuId,ADDR从参数设置表中取出对应的记录,单个参数配置处理")
  public SmartView loadPInfoByRtuid(int rtuId, int zone, int type, List<Map<String, Object>> paramList) {
    return SmartView.SUCCESS(this.rtuSettingsService.listRtuParamByRtuId(rtuId, zone, type, paramList));
  }
  
  @SmartComment("保存定值区域记录")
  public SmartView saveZone(Map<String, Object> zoneMap) {
    return SmartView.SUCCESS(Long.valueOf(this.rtuZoneService.saveZone(zoneMap)));
  }
  
  @SmartComment("保存操作记录")
  public SmartView saveOperation(List<Map<String, Object>> operationList) {
    return SmartView.SUCCESS(this.rtuOptEventService
        .saveOperation(operationList));
  }
  
  @SmartComment("批量保存操作记录")
  public SmartView saveOperationList(List<RtuOptEvent> operationList) {
    return SmartView.SUCCESS(this.rtuOptEventService.saveList(operationList));
  }
  
  @SmartComment("修改操作记录表中文件状态")
  public SmartView updateFileStatus(List<Integer> rtuList) {
    return SmartView.SUCCESS(this.rtuOptEventService
        .updateFileStatus(rtuList));
  }
  
  @SmartComment("获取rtu与站点关联关系")
  public SmartView listRtuByStationLink() {
    return 
      SmartView.SUCCESS(this.rtuSettingsService.listRtuByStationLink());
  }
  
  @SmartComment("通过终端视图树获取rtu电池信息")
  public SmartView rtuBatteryListByType(Integer orgId, Integer orgLevel, Long stationId, Long feederId, Integer rtuType, Integer rtuId, String name, Integer pageSize, Integer pageIndex, String columns, String method) {
    QueryFilter filter = new QueryFilter();
    filter.setPageInfo(pageSize, pageIndex);
    PagingBean page = this.fesRtuService.loadRtuBatteryList(orgId, orgLevel, stationId, feederId, rtuType, rtuId, name, filter);
    if ("export".equals(method)) {
      List<HeaderConfig> headers = JsonUtil.getBeanListByJsonArray(columns, HeaderConfig.class);
      ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
      try {
        ExcelDataUtil.createExcelByMapList(page.getData(), headers).write(outputStream);
      } catch (IOException e) {
        return SmartView.ERROR(I18n.message("error.excel.export", new Object[] { e
                .getMessage() }));
      } 
      return SmartView.FileView(outputStream, "蓄电池状态.xls");
    } 
    return SmartView.PAGEDATA(page);
  }
  
  public SmartView rtuStateListByType(Integer orgId, Integer orgLevel, Long stationId, Long feederId, Integer rtuType, Integer rtuId, String name, Integer pageSize, Integer pageIndex, String columns, String method) {
    QueryFilter filter = new QueryFilter();
    filter.setPageInfo(pageSize, pageIndex);
    PagingBean page = this.fesRtuService.loadRtuStateList(orgId, orgLevel, stationId, feederId, rtuType, rtuId, name, filter);
    if ("export".equals(method)) {
      List<HeaderConfig> headers = JsonUtil.getBeanListByJsonArray(columns, HeaderConfig.class);
      ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
      try {
        ExcelDataUtil.createExcelByMapList(page.getData(), headers).write(outputStream);
      } catch (IOException e) {
        return SmartView.ERROR(I18n.message("error.excel.export", new Object[] { e
                .getMessage() }));
      } 
      return SmartView.FileView(outputStream, "终端状态感知.xls");
    } 
    return SmartView.PAGEDATA(page);
  }
  
  private List<Map<String, Object>> getRecords(List<Map<String, Object>> list, String sPKF, String sFKF, String sVF, String scadaPntId) {
    List<Map<String, Object>> results = new ArrayList<>();
    if (list instanceof List && list.size() > 0) {
      Map<Object, Object> rowDataCatch = new HashMap<>();
      Set<String> colSet = getColSet(list, sFKF, sVF, scadaPntId);
      Object pk = ((Map)list.get(0)).get(sPKF);
      for (int i = 0, len = list.size(); i < len; i++) {
        Map record = list.get(i);
        if (i == len - 1 || !record.get(sPKF).equals(pk)) {
          if (i == len - 1) {
            if (record.get(sFKF).equals("batteryactivation"))
              rowDataCatch.put("batteryactivationscadaPntId", record
                  .get("scadaPntId")); 
            rowDataCatch.put(record.get(sFKF), record.get(sVF));
          } 
          Map<Object, Object> preRecord = (Map)list.get(i - 1);
          preRecord.remove(sFKF);
          preRecord.remove(sVF);
          preRecord.putAll(rowDataCatch);
          addRecord(results, colSet, preRecord);
          rowDataCatch.clear();
          pk = record.get(sPKF);
        } 
        if (i < len - 1) {
          if (record.get(sFKF).equals("batteryactivation"))
            rowDataCatch.put("batteryactivationscadaPntId", record
                .get("scadaPntId")); 
          rowDataCatch.put(record.get(sFKF), record.get(sVF));
        } 
      } 
    } 
    return results;
  }
  
  private Set<String> getColSet(List<Map<String, Object>> list, String sFKF, String sVF, String scadaPntId) {
    Set<String> colSet = new HashSet<>();
    if (list instanceof List && list.size() > 0) {
      Map record = list.get(0);
      for (Object key : record.keySet()) {
        if (!key.equals(sFKF) && !key.equals(sVF) && 
          !key.equals(scadaPntId))
          colSet.add(key.toString()); 
      } 
      for (Map<String, Object> item : list) {
        colSet.add((String)item.get(sFKF));
        colSet.add((String)item.get(sFKF) + "scadaPntId");
      } 
    } 
    return colSet;
  }
  
  private void addRecord(List<Map<String, Object>> list, Set<String> colSet, Map<String, Object> rowData) {
    for (String column : colSet) {
      if (!rowData.containsKey(column))
        rowData.put(column, null); 
    } 
    list.add(rowData);
  }
  
  public SmartView chanInfoList() {
    return SmartView.SUCCESS(this.fesRtuService.chanInfoList());
  }
  
  @SmartComment("保存FesRtu实例")
  public SmartView save(FesRtu fesRtu) {
    return dbAccess(this.fesRtuService.save(fesRtu));
  }
  
  @SmartComment("按ID列表删除FesRtu对象")
  public SmartView delete(List<Integer> ids) {
    return dbAccess(this.fesRtuService.delete(ids, false));
  }
  
  @SmartComment("按ID列表彻底删除FesRtu对象")
  public SmartView deletePermanently(List<Integer> ids) {
    return dbAccess(this.fesRtuService.delete(ids, false));
  }
  
  @SmartComment("按ID获取单个FesRtu实例")
  public SmartView loadOne(Integer id) {
    return SmartView.SUCCESS(this.fesRtuService.get(id));
  }
  
  @SmartComment("按ID获取单个FesRtu实例")
  public SmartView getRtuByLastTime(Integer rtuid) {
    return SmartView.SUCCESS(this.fesRtuService.getRtuByLastTime(rtuid));
  }
  
  @SmartComment("获取FesRtu实例的分页查询结果")
  public SmartView list(String name, Integer pageSize, Integer pageIndex, String sortField, String sortOrder, String columns, String method) {
    QueryFilter queryFilter = new QueryFilter();
    if (!ParameterUtils.isEmptyOrNull(name))
      queryFilter.addStringFieldLikeCondition("e.name", name); 
    if (pageSize == null || pageIndex == null)
      return SmartView.ERROR(I18n.message("error.parameter.empty", "分页参数{0}不能为空", new Object[] { "pageIndex,pageSize" })); 
    queryFilter.addSorted(sortField, sortOrder);
    queryFilter.setPageInfo(pageSize, pageIndex);
    PagingBean page = this.fesRtuService.queryRecords(queryFilter);
    return pageView(page);
  }
  
  @SmartComment("Excel文件导入")
  public SmartView importFile(File file) {
    return SmartView.SUCCESS();
  }
  
  public SmartView rtuStatusHisInfo(Date start_time) throws Exception {
    return SmartView.SUCCESS(this.fesRtuService
        .rtuStatusHisInfo(start_time));
  }
  
  public SmartView listChannelInfo(Integer orgId, Integer orgLevel, Long stationId, Long feederId, Long rtuId, Integer rtuType, String rtuStatus, Integer flowStatus, String description, Integer pageIndex, Integer pageSize, String sortField, String sortOrder, String method, String columns) {
    PagingBean bean = this.fesRtuService.getChannelInfoList(orgId, orgLevel, stationId, feederId, rtuId, rtuType, 
        Integer.valueOf(rtuStatus), flowStatus, description, pageSize, pageIndex, sortField, sortOrder);
    if ("export".equals(method)) {
      List<HeaderConfig> headers = JsonUtil.getBeanListByJsonArray(columns, HeaderConfig.class);
      ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
      try {
        ExcelDataUtil.createExcelByMapList(bean.getData(), headers).write(outputStream);
      } catch (IOException e) {
        return SmartView.ERROR(I18n.message("error.excel.export", new Object[] { e
                .getMessage() }));
      } 
      return SmartView.FileView(outputStream, "通道运行工况.xls");
    } 
    return pageView(bean);
  }
  
  public SmartView loadChartData(Integer orgId, Integer orgLevel, Long stationId, Long feederId, Integer pageIndex, Integer pageSize) {
    PagingBean bean = this.fesRtuService.getChannelInfoList(orgId, orgLevel, stationId, feederId, null, 
        Integer.valueOf(-1), Integer.valueOf(-1), Integer.valueOf(-1), "", pageSize, pageIndex, null, null);
    if (bean.getData() != null && !bean.getData().isEmpty()) {
      Map<String, Integer> re = new HashMap<>();
      int noflow = 0;
      int normal = 0;
      int overflow = 0;
      int online = 0, offline = 0;
      for (Map<String, Object> item : (Iterable<Map<String, Object>>)bean.getData()) {
        if (Integer.valueOf(item.get("status").toString()).intValue() == 1) {
          online++;
          if (item.get("curFlowRecv") == null || item.get("curFlowSend") == null) {
            noflow++;
            continue;
          } 
          Double flow = Double.valueOf(
              Double.valueOf(item.get("curFlowRecv").toString()).doubleValue() + 
              Double.valueOf(item.get("curFlowSend").toString()).doubleValue());
          Double flowlimit = Double.valueOf(item.get("flowLimit1")
              .toString());
          if (flow.equals(Double.valueOf(0.0D))) {
            noflow++;
            continue;
          } 
          if (flow.compareTo(flowlimit) > 0) {
            overflow++;
            continue;
          } 
          normal++;
          continue;
        } 
        offline++;
        noflow++;
      } 
      re.put("normal", Integer.valueOf(normal));
      re.put("noflow", Integer.valueOf(noflow));
      re.put("overflow", Integer.valueOf(overflow));
      re.put("online", Integer.valueOf(online));
      re.put("offline", Integer.valueOf(offline));
      return SmartView.SUCCESS(re);
    } 
    return SmartView.SUCCESS();
  }
  
  public SmartView loadChannelInfoByRtu(Integer rtuId) {
    return SmartView.SUCCESS(this.fesRtuService.getChannelInfoByRtu(rtuId));
  }
  
  public SmartView loadRtuOnlinePnt() {
    List<Map<String, Object>> list = this.fesRtuService.getRtuOnlinePnt();
    if (list == null)
      return SmartView.ERROR("获取终端在线率失败"); 
    Map<String, String> re = new HashMap<>();
    for (Map<String, Object> item : list)
      re.put(item.get("postfix").toString(), item.get("id").toString()); 
    return SmartView.SUCCESS(re);
  }
  
  public SmartView loadAllFlowPnt(Integer chanId) {
    Map<String, String> re = new HashMap<>();
    String pntId = this.fesRtuService.loadAllFlowPnt(chanId);
    re.put("pntId", pntId);
    return SmartView.SUCCESS(re);
  }
  
  public SmartView exportFileHistory(String columns, String tableData) {
    try {
      List<HeaderConfig> headers = JsonUtil.getBeanListByJsonArray(columns, HeaderConfig.class);
      ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
      ExcelDataUtil.createExcelByMapList(JsonUtil.getMapListByJson(tableData), headers).write(outputStream);
      return SmartView.FileView(outputStream, "历史文件详情.xls");
    } catch (Exception e) {
      e.printStackTrace();
      return SmartView.SUCCESS();
    } 
  }
  
  @SmartComment("获取通道历史流量统计列表")
  public SmartView listChanHistoryFlow(Integer orgId, Integer orgLevel, Long stationId, Long feederId, Long channelId, Integer rtuType, Integer menuFac, Integer statType, Long statTime, String channelDesc, Long rtuId, Integer pageIndex, Integer pageSize, String sortField, String sortOrder, String columns, String method) throws Exception {
    QueryFilter filter = new QueryFilter();
    if (!ParameterUtils.isValidateId(pageIndex) || !ParameterUtils.isValidateId(pageSize))
      throw new Exception(I18n.paraEmptyMsg("pageIndex,pageSize")); 
    filter.setPageInfo(pageSize, pageIndex);
    if (!ParameterUtils.isEmptyOrNull(rtuType))
      filter.addNumberFieldEqualCondition("fes_rtu.type", rtuType); 
    if (!ParameterUtils.isEmptyOrNull(menuFac))
      filter.addNumberFieldEqualCondition("fes_rtu.manu_fac", menuFac); 
    if (sortField.equals("maxValue"))
      filter.addSorted("e.max_value", sortOrder); 
    if (sortField.equals("minValue"))
      filter.addSorted("e.min_value", sortOrder); 
    if (sortField.equals("avgValue"))
      filter.addSorted("e.avg_value", sortOrder); 
    StringBuilder sb = new StringBuilder("select fes_rtu.type,fes_rtu.manu_fac,fes_chan.description as channel_desc,");
    sb.append("CAST(e.id AS VARCHAR(20)) id,e.statics_time,round(e.max_value,2) max_value,e.max_time, ")
      .append("round(e.min_value,2) min_value,e.min_time,round(e.diff_value,2) diff_value,round(e.avg_value) avg_value ")
      .append("from fes_chan left join pnt_ana on pnt_ana.container_id = fes_chan.dev_id and pnt_ana.postfix = 'all_flow'")
      .append("left join ");
    if (statType.intValue() == 1) {
      sb.append("statistics_ana_day e ");
    } else if (statType.intValue() == 2) {
      sb.append("statistics_ana_month e ");
    } 
    sb.append("on pnt_ana.id = e.id ");
    if (statType.intValue() == 1) {
      Date date = new Date(statTime.longValue());
      date = DateUtil.addDays(date, 1);
      sb.append(" and e.statics_time = '").append(DateUtil.format(date)).append("' ");
    } else if (statType.intValue() == 2) {
      Date date = new Date(statTime.longValue());
      date = DateUtil.addMonths(date, 1);
      sb.append(" and e.statics_time = '").append(DateUtil.format(date)).append("' ");
    } 
    sb.append("inner join fes_rtu on fes_rtu.sour1 = fes_chan.id ");
    if (ParameterUtils.isValidateId(channelId))
      filter.addNumberFieldEqualCondition("e.id", channelId); 
    if (ParameterUtils.isValidateId(rtuId))
      filter.addNumberFieldEqualCondition("fes_rtu.id", rtuId); 
    if (ParameterUtils.isValidateId(feederId))
      sb.append("inner join auth_orgrtu on auth_orgrtu.rtu_id = fes_rtu.id and auth_orgrtu.container_id=")
        .append(feederId); 
    if (ParameterUtils.isValidateId(orgId))
      sb.append("inner join (select distinct ort.rtu_id from auth_orgrtu ort inner join (")
        .append(SysCommUtil.userAuthOrgLinkSQL(orgLevel, orgId))
        .append(") org on ort.org_id=org.user_auth_org_id) org_feeder on org_feeder.rtu_id=fes_rtu.id"); 
    if (channelDesc != "")
      filter.addStringFieldLikeCondition("fes_chan.description", channelDesc); 
    PagingBean page = this.fesRtuService.getChanFlowHistoryRecords(sb.toString(), filter);
    if ("export".equals(method)) {
      List<HeaderConfig> headers = JsonUtil.getBeanListByJsonArray(columns, HeaderConfig.class);
      ByteArrayOutputStream outputStream = new ByteArrayOutputStream();
      try {
        ExcelDataUtil.createExcelByMapList(page.getData(), headers).write(outputStream);
      } catch (IOException e) {
        return SmartView.ERROR(I18n.message("error.excel.export", new Object[] { e
                .getMessage() }));
      } 
      return SmartView.FileView(outputStream, "通道历史流量统计.xls");
    } 
    return pageView(page);
  }
  
  public SmartView listOneChanHistoryFlow(Long id, Integer statType, Long startTime, Long endTime, String sortField, String sortOrder) {
    if (ParameterUtils.isEmptyOrNull(id))
      return pageView(new PagingBean(-1, 1, null)); 
    QueryFilter filter = new QueryFilter();
    StringBuilder sb = new StringBuilder("select statics_time, round(max_value,2) max_value,max_time,");
    sb.append("round(min_value,2) min_value,min_time,round(avg_value,2) avg_value ");
    if (statType.intValue() == 1) {
      Date pre = new Date(startTime.longValue());
      pre = DateUtil.addDays(pre, 1);
      Date end = new Date(endTime.longValue());
      end = DateUtil.addDays(end, 1);
      sb.append("from statistics_ana_day");
      filter.addNumberFieldEqualCondition("id", id);
      filter.addDateFieldBetweenCondition("statics_time", pre, end);
    } else {
      Date pre = new Date(startTime.longValue());
      Calendar c = Calendar.getInstance();
      c.setTime(pre);
      c.set(5, 1);
      c.add(2, 1);
      pre = c.getTime();
      Date end = new Date(endTime.longValue());
      Calendar cl = Calendar.getInstance();
      cl.setTime(end);
      cl.set(5, 1);
      cl.add(2, 1);
      end = cl.getTime();
      sb.append("from statistics_ana_month");
      filter.addNumberFieldEqualCondition("id", id);
      filter.addDateFieldBetweenCondition("statics_time", pre, end);
    } 
    if (sortField.equals("staticsTime"))
      filter.addSorted("statics_time", sortOrder); 
    if (sortField.equals("maxValue"))
      filter.addSorted("max_value", sortOrder); 
    if (sortField.equals("minValue"))
      filter.addSorted("min_value", sortOrder); 
    if (sortField.equals("avgValue"))
      filter.addSorted("avg_value", sortOrder); 
    PagingBean pagingBean = this.fesRtuService.getOneChanHistoryFlow(sb.toString(), filter);
    return pageView(pagingBean);
  }
  
  @SmartComment("根据通道名称模糊检索获取通道列表")
  public SmartView listChanByDesc(Integer orgId, Integer orgLevel, Long stationId, Long feederId, Long channelId, Integer rtuType, Integer menuFac, Integer statType, Long statTime, String channelDesc, Integer pageIndex, Integer pageSize) {
    StringBuilder sb = new StringBuilder("select CAST(e.id AS VARCHAR(20)) id,fes_chan.description as channel_desc from ");
    if (statType.intValue() == 1) {
      sb.append("statistics_ana_day e ");
    } else if (statType.intValue() == 2) {
      sb.append("statistics_ana_month e ");
    } 
    sb.append("inner join pnt_ana on pnt_ana.id = e.id and pnt_ana.postfix = 'all_flow' ");
    sb.append("inner join fes_chan on fes_chan.dev_id = pnt_ana.container_id ");
    sb.append("inner join fes_rtu on fes_rtu.sour1 = fes_chan.id ");
    QueryFilter filter = new QueryFilter();
    if (statType.intValue() == 1) {
      Date date = new Date(statTime.longValue());
      date = DateUtil.addDays(date, 1);
      filter.addStringFieldEqualCondition("e.statics_time", DateUtil.format(date));
    } else if (statType.intValue() == 2) {
      Date date = new Date(statTime.longValue());
      date = DateUtil.addMonths(date, 1);
      filter.addStringFieldEqualCondition("e.statics_time", DateUtil.format(date));
    } 
    if (ParameterUtils.isValidateId(channelId))
      filter.addNumberFieldEqualCondition("e.id", channelId); 
    if (ParameterUtils.isValidateId(stationId))
      sb.append("inner join auth_orgrtu on auth_orgrtu.rtu_id = fes_rtu.id and auth_orgrtu.station_id=")
        .append(stationId); 
    if (ParameterUtils.isValidateId(feederId))
      sb.append("inner join auth_orgrtu on auth_orgrtu.rtu_id = fes_rtu.id and auth_orgrtu.container_id=")
        .append(feederId); 
    if (ParameterUtils.isValidateId(orgId))
      sb.append("inner join (select distinct ort.rtu_id from auth_orgrtu ort inner join (")
        .append(SysCommUtil.userAuthOrgLinkSQL(orgLevel, orgId))
        .append(") org on ort.org_id=org.user_auth_org_id) org_feeder on org_feeder.rtu_id=fes_rtu.id"); 
    if (ParameterUtils.isEmptyOrNull(channelDesc))
      channelDesc = ""; 
    filter.addStringFieldLikeCondition("fes_chan.description", channelDesc);
    PagingBean pagingBean = this.jdbcDao.queryForPaging(sb.toString() + filter.getWhereSql(), filter.getConditionValues(), pageSize.intValue(), pageIndex.intValue());
    return SmartView.PAGEDATA(pagingBean);
  }
  
  public SmartView loadFesNodeStatusDefine() {
    return SmartView.SUCCESS(this.fesRtuService.getFesNodeStatusDefine());
  }
  
  public SmartView updateRealFlowLimit(Long id, Double flowLimit1) {
    if (ParameterUtils.isEmptyOrNull(id))
      return SmartView.ERROR("id为空"); 
    if (ParameterUtils.isEmptyOrNull(flowLimit1))
      return SmartView.ERROR("flowLimit为空"); 
    try {
      return SmartView.SUCCESS(Integer.valueOf(this.fesRtuService.updateRealFlowLimit(id, flowLimit1)));
    } catch (Exception e) {
      this.logger.warn("Save flowLimit Error", e);
      return SmartView.ERROR(I18n.message("parameter.not.valid", e.getMessage()));
    } 
  }
  
  public static void main(String[] args) {
    Base64 base64 = new Base64();
    String string = "APPKEY:+MASTERSECRET";
    try {
      String base64Sign = base64.encodeToString(string.getBytes("UTF-8"));
      System.out.println(base64Sign);
    } catch (UnsupportedEncodingException e) {
      e.printStackTrace();
    } 
  }
}
